#!/bin/sh
set -e

archive_tree=.archive/PLD
other_tree=$1
ftp_dir=~ftp/pld/dists/th

die() {
	echo >&2 "$*"
	exit 1
}


test -n "$other_tree" || die 'specify other tree, ex: 2015/PLD'

archive_dir=$ftp_dir/$archive_tree/SRPMS/.metadata
other_dir=$ftp_dir/$other_tree/SRPMS/.metadata

test -d "$archive_dir" || die '$archive_dir not a dir'
test -d "$other_dir" || die '$other_dir not a dir'

match_pkgs() {
	for f in $archive_dir/*.info; do
		fn=${f##*/}
		if [ -f "$other_dir/$fn" ]; then
			echo $fn
		fi
	done
}

remove_pkgs=$(match_pkgs)
test -n "$remove_pkgs" || die "nothing matched"
c=$(echo "$remove_pkgs" | wc -l)
echo >&2 "$c packages to remove from $archive_dir. ctrl-c to abort"
read a

echo >&2 pfa-rmpkg $archive_tree $remove_pkgs
pfa-rmpkg $archive_tree $remove_pkgs
