#!/bin/sh
# stat(1) each file in .info to see if they exist

REPODIR=${1:-/home/pld/admins/th/ftp/test}

# expand files from .info file
expand_info() {
	awk -F ':' -vD="$REPODIR/" '
		/file:/ {
			if (/-debuginfo-/) {
				print D $2 "/debuginfo/" $3
			} else {
				print D $2 "/RPMS/" $3
			}
		}
	' "$@"
}

i=0
nn=
ls -1 $REPODIR/SRPMS/RPMS | sed -rne "s/^((.+)-[^-]+-[^-]+\.src\.rpm)$/\1.info/p" | \
while read pkg; do
	for f in $(expand_info $REPODIR/SRPMS/.metadata/$pkg); do
		if ! stat $f >/dev/null; then
			echo "!!!: $pkg : $f" >&2
		fi
	done
done
